options ls=78;

/*

program to perform simulation study to investigate distribution of the

correlation r and Fisher's z

*/

proc iml;

* set sample size equal to n = 10 or 100;

* set correlation coefficient equal to rho = 0, 0.3, 0.6, 0.9;

* set number of repetitions of sampling experiment = totreps = 1000;

* CHANGE YOUR N AND RHO;



n = 10;

rho = 0.9;

totreps = 1000;

r = j(totreps,1);

do reps = 1 to totreps;

   u = j(n,1);  x=j(n,1);  y=j(n,1);

   do j= 1 to n;



* SUBSTITUTE A LARGE RANDOM NUMBER FOR SEED1 AND SEED2; 

           SEED1 = 83683;  SEED2 = 51426;



          u[j] = rannor(SEED1);

	  y[j] = rannor(SEED2);

	  x[j] = sqrt(1 - rho*rho) * u[j] + rho * y[j];

   end;

*   print reps;

*   print u y x;

xbar = sum(x) / n;  ybar=sum(y) / n;

devx = x - J(n,1,xbar);

devy = y - J(n,1,ybar);

cov = devx` * devy;

varx = devx` * devx;

vary = devy` * devy;

r[reps] = cov / sqrt(varx * vary);



end;



* create a SAS data set called simcorr, containing 1000 correlations r;



create simcorr from r[colname='r'];

append from r;



close simcorr;

quit;



* create a SAS data set called simcorr1, which contains r and z;

data simcorr1;

   set simcorr;

* SUBSTITUTE YOUR VALUE OF N AND RHO;

   rho = 0.9;  n = 10;

* calculate Fisher z;

   z = 0.5 * log((1+r)/(1-r));

   meanz = 0.5 * log((1 + rho) / (1 - rho));

   varz = 1 / (n - 3);

   lowz = z - 1.96 * sqrt(varz);

   upz = z + 1.96*sqrt(varz);

   lowrho = (exp(2*lowz) - 1) / (1 + exp(2*lowz));

   uprho = (exp(2*upz) - 1) / (1 + exp(2*upz));

   if rho <= lowrho then toolow = 1;  else toolow = 0;

   if rho >= uprho then toohigh = 1;  else toohigh = 0;

proc means;

* CHANGE TITLE FOR MORE DESCRIPTIVE OUTPUT;

   title 'rho = 0.9 and n = 10';

   var  toolow toohigh;

proc univariate plot normal;

   title 'rho = 0.9 and n = 10';

   var r z;

run;



